unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Grids, MemDumpView, asaCDlg,
  asa_mmf;

type
  TFormMain = class(TForm)
    MainMenu1: TMainMenu;
    MenuItemFile: TMenuItem;
    MenuItemHelp: TMenuItem;
    MenuItemOpen: TMenuItem;
    N1: TMenuItem;
    MenuItemExit: TMenuItem;
    MenuItemAbout: TMenuItem;
    MemDumpView: TMemDumpView;
    asaAboutBox1: TasaAboutBox;
    View1: TMenuItem;
    HexDecimal1: TMenuItem;
    Char1: TMenuItem;
    Decimal1: TMenuItem;
    asaMMF1: TasaMMF;
    procedure FormCreate(Sender: TObject);
    procedure MenuItemExitClick(Sender: TObject);
    procedure MenuItemOpenClick(Sender: TObject);
    procedure MenuItemAboutClick(Sender: TObject);
    procedure ViewClick(Sender: TObject);
  private
    CapHdr: String;
    procedure FileHexView(const FName: String);
    //
    procedure AppMinimize(Sender: TObject);
    procedure AppRestore(Sender: TObject);
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

procedure TFormMain.FileHexView(const FName: String);
begin
  MemDumpView.SetData(nil,0);
  asaMMF1.Close;
  //
  asaMMF1.FileName := FName;
  if FName <> '' then
    Caption := FName + ' - ' + CapHdr
  else
    Caption := CapHdr;
  //
  asaMMF1.Open;
  MemDumpView.SetData(asaMMF1.Data,asaMMF1.GetRealMapSize);
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Application.OnMinimize := AppMinimize;
  Application.OnRestore  := AppRestore;
  //
  CapHdr := Caption;
  if (ParamCount > 0) and FileExists(ParamStr(1)) then
    FileHexView(ParamStr(1));
end;

procedure TFormMain.MenuItemExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.MenuItemOpenClick(Sender: TObject);
var
  FD: TOpenDialog;
begin
  FD := TOpenDialog.Create(nil);
  FD.FileName := '';
  try
    if FD.Execute then
      FileHexView(FD.FileName);
  finally
    FD.Free;
  end;
end;

procedure TFormMain.MenuItemAboutClick(Sender: TObject);
begin
  asaAboutBox1.Execute;
end;

procedure TFormMain.AppMinimize(Sender: TObject);
begin
  Application.Title := Caption;
end;

procedure TFormMain.AppRestore(Sender: TObject);
begin
  Application.Title := CapHdr;
end;

const
  old_MI: TMenuItem = nil;

procedure TFormMain.ViewClick(Sender: TObject);
const
  ViewTypeArray: array[1..3] of TViewType = (vtHexByte,vtChar,vtDecimalByte);
begin
  MemDumpView.ViewType := ViewTypeArray[(Sender as TMenuItem).Tag];
  if old_MI <> nil then
    old_MI.Checked := False;
  (Sender as TMenuItem).Checked := True;
  old_MI := (Sender as TMenuItem);
end;

end.
